#include <cstdio>
#include <cassert>

using namespace std;
typedef long long ll;

struct segment {
  ll first, step, count;
};

const int MAXN = 200000;

segment v[MAXN];
int ptr;

void insert(segment s) {
  int i;
  for (i = ptr - 1; i >= 0; i--) {
    if (v[i].first < s.first) {
      break;
    }
    v[i + 1] = v[i];
  }
  ptr++;
  v[i + 1] = s;
}

void remove(ll val) {
  int i;
  for (i = ptr - 1; i >= 0; i--) {
    if (v[i].first == val) break;
  }
  ptr--;
  for (; i < ptr; i++) {
    v[i] = v[i + 1];
  }
}

int get_kth(ll &k) {
  for (int i = 0; i < ptr; i++) {
    if (v[i].count > k) {
      return i;
    }
    k -= v[i].count;
  }
  return ptr;
}

int split_count(ll count) {
  int temp = get_kth(count);
  if (temp == ptr) {
    return ptr;
  }
  if (count != 0) {
    segment nseg = {v[temp].first, v[temp].step, count};
    v[temp].first += v[temp].step * count;
    v[temp].count -= count;
    insert(nseg);
    return temp + 1;
  }
  return temp;
}



int main() {
  int n;
  scanf("%d", &n);
  ll m;
  scanf("%lld", &m);
  v[0] = {1, 1, m};
  ptr++;

  for (int i = 0; i < n; i++) {
    ll l, r;
    scanf("%lld %lld", &l, &r);
    int from = split_count(l - 1);
    int to = split_count(r);
 
    printf("%lld %lld\n", v[from].first, v[to - 1].first + v[to - 1].step * (v[to - 1].count - 1));

    bool any = false;
    int shift = 1;
    for (int i = from; i < to; i++) {
      if (shift == 1) {
        v[i].first += v[i].step;
        v[i].count -= 1;
        shift = 0;
      }
      v[i].step *= 2;
      shift = v[i].count % 2;
      v[i].count = (v[i].count + 1) / 2;
      if (v[i].count == 0) any = true;
    }

    if (any) {
      int pptr = from;
      for (int i = from; i < ptr; i++) {
        if (v[i].count > 0) {
          v[pptr++] = v[i];
        }
      }
      ptr = pptr;
    }
  }
}
